Index: trunk/kernel/kern/rpc.c
===================================================================
--- trunk/kernel/kern/rpc.c	(revision 690)
+++ trunk/kernel/kern/rpc.c	(revision 1)
@@ -718,31 +369,20 @@
 void rpc_thread_user_create_server( xptr_t xp )
 {
-#if DEBUG_RPC_THREAD_USER_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_THREAD_USER_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
     pthread_attr_t * attr_ptr;   // pointer on attributes structure in client cluster 
     pthread_attr_t   attr_copy;  // attributes structure  copy in server cluster
     thread_t       * thread_ptr; // local pointer on thread descriptor
     xptr_t           thread_xp;  // extended pointer on thread descriptor
-
     pid_t            pid;        // process identifier
-    void           * start_func;
-    void           * start_arg;
-    error_t          error;
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get input arguments from RPC descriptor
-    pid        = (pid_t)                     hal_remote_l64(XPTR(client_cxy , &desc->args[0]));
-    start_func = (void *)(intptr_t)          hal_remote_l64(XPTR(client_cxy , &desc->args[1]));
-    start_arg  = (void *)(intptr_t)          hal_remote_l64(XPTR(client_cxy , &desc->args[2]));
-    attr_ptr   = (pthread_attr_t *)(intptr_t)hal_remote_l64(XPTR(client_cxy , &desc->args[3]));
+    process_t      * process;    // local pointer on process descriptor
+    vseg_t         * vseg;       // local pointer on stack vseg
+
+    error_t          error = 0;
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
+
+    // get pointer on attributes structure in client cluster from RPC descriptor
+    attr_ptr = (pthread_attr_t *)(intptr_t)hal_remote_lwd( XPTR(client_cxy , &desc->args[0]) );
 
     // makes a local copy of attributes structure
@@ -751,25 +391,50 @@
                        sizeof(pthread_attr_t) );
     
-    // call kernel function
-    error = thread_user_create( pid,
-                                start_func,
-                                start_arg,
-                                &attr_copy,
-                                &thread_ptr );
+    if( attr_copy.cxy != local_cxy )
+    {
+        printk("\n[PANIC] in %s : target cluster = %X / local_cluster = %x\n",
+               __FUNCTION__ , attr_copy.cxy , local_cxy );
+        hal_core_sleep();
+    }
+
+    // get local process descriptor
+    pid     = attr_copy.pid; 
+    process = cluster_get_local_process_from_pid( pid );
+
+    if( process == NULL )
+    {
+        printk("\n[ERROR] in %s : no process descriptor in cluster %x for pid = %x\n",
+               __FUNCTION__ , local_cxy , pid );
+        error = ENOMEM;
+       
+    }
+
+    // allocate a stack from local VMM 
+    vseg = vmm_create_vseg( process, 
+                            0,
+                            0,
+                            VSEG_TYPE_STACK );
+    if( vseg == NULL )
+    {
+        printk("\n[ERROR] in %s : cannot create stack vseg in cluster %x for pid %x\n",
+               __FUNCTION__ , local_cxy , pid );
+        error = ENOMEM;
+    } 
+
+    // create thread in local cluster
+    if( thread_user_create( &thread_ptr,
+                            &attr_copy,
+                            vseg->min,
+                            vseg->max - vseg->min ) ) error = ENOMEM;
+
+
     // set output arguments
     thread_xp = XPTR( local_cxy , thread_ptr );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[4] ) , (uint64_t)thread_xp );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[5] ) , (uint64_t)error );
-
-#if DEBUG_RPC_THREAD_USER_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_THREAD_USER_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [7]      Marshaling functions attached to RPC_THREAD_KERNEL_CREATE 
+    hal_remote_swd( XPTR( client_cxy , &desc->args[1] ) , (uint64_t)error );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[2] ) , (uint64_t)thread_xp );
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_THREAD_KERNEL_CREATE
 /////////////////////////////////////////////////////////////////////////////////////////
 
@@ -782,19 +447,15 @@
                                       error_t * error )      // out
 {
-#if DEBUG_RPC_THREAD_KERNEL_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_THREAD_KERNEL_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    uint32_t responses = 1;
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 
     // initialise RPC descriptor header 
     rpc_desc_t  rpc;
     rpc.index    = RPC_THREAD_KERNEL_CREATE;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
@@ -804,16 +465,9 @@
     
     // register RPC request in remote RPC fifo 
-    rpc_send( cxy , &rpc );
+    rpc_send_sync( cxy , &rpc );
 
     // get output arguments from RPC descriptor
     *thread_xp = (xptr_t)rpc.args[3];
     *error     = (error_t)rpc.args[4];
-
-#if DEBUG_RPC_THREAD_KERNEL_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_THREAD_KERNEL_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
 }
 
@@ -821,12 +475,4 @@
 void rpc_thread_kernel_create_server( xptr_t xp )
 {
-#if DEBUG_RPC_THREAD_KERNEL_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_THREAD_KERNEL_CREATE)
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
     thread_t       * thread_ptr;  // local pointer on thread descriptor
     xptr_t           thread_xp;   // extended pointer on thread descriptor
@@ -835,14 +481,14 @@
 
     // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
 
     // get attributes from RPC descriptor
-    uint32_t  type = (uint32_t)       hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
-    void    * func = (void*)(intptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[1] ) );
-    void    * args = (void*)(intptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[2] ) );
+    uint32_t  type = (uint32_t)       hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
+    void    * func = (void*)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[1] ) );
+    void    * args = (void*)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[2] ) );
 
     // select one core
-    core_lid = cluster_select_local_core( local_cxy );
+    core_lid = cluster_select_local_core();
 
     // call local kernel function
